<?php
/**
* @version 			SEBLOD 3.x More
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/

defined( '_JEXEC' ) or die;

global $user;

$app		=	JFactory::getApplication();
$path_lib	=	JPATH_SITE.'/libraries/cck/rendering/rendering.php';
$user		=	JCck::getUser();

if ( ! file_exists( $path_lib ) ) {
	print( '/libraries/cck/rendering/rendering.php file is missing.' );
	die;
}

require_once $path_lib;

// pulsar_calendar_getLabels
if ( !function_exists( 'pulsar_calendar_getLabels' ) ) {
	function pulsar_calendar_getLabels( $format = 0 )
	{

		$js	=	"\n".'months : [ "'.JText::_( 'JANUARY' ).'", "'.JText::_( 'FEBRUARY' ).'", "'.JText::_( 'MARCH' ).'", "'.JText::_( 'APRIL' ).'", "'.JText::_( 'MAY' ).'", "'.JText::_( 'JUNE' ).'", "'.JText::_( 'JULY' ).'", "'.JText::_( 'AUGUST' ).'", "'.JText::_( 'SEPTEMBER' ).'", "'.JText::_( 'OCTOBER' ).'", "'.JText::_( 'NOVEMBER' ).'", "'.JText::_( 'DECEMBER' ).'" ],'
			.	"\n".'monthabbrs : [ "'.JText::_( 'JAN' ).'", "'.JText::_( 'FEB' ).'", "'.JText::_( 'MAR' ).'", "'.JText::_( 'APR' ).'", "'.JText::_( 'MAY' ).'", "'.JText::_( 'JUN' ).'", "'.JText::_( 'JUL' ).'", "'.JText::_( 'AUG' ).'", "'.JText::_( 'SEP' ).'", "'.JText::_( 'OCT' ).'", "'.JText::_( 'NOV' ).'", "'.JText::_( 'DEC' ).'" ],';
			
		if ( $format == 2 ) {
			$days	=	array(
							'SUNDAY'=>JText::_( 'SUN' ),
							'MONDAY'=>JText::_( 'MON' ),
							'TUESDAY'=>JText::_( 'TUE' ),
							'WEDNESDAY'=>JText::_( 'WED' ),
							'THURSDAY'=>JText::_( 'THU' ),
							'FRIDAY'=>JText::_( 'FRI' ),
							'SATURDAY'=>JText::_( 'SAT' )
						);
			$js		.=	"\n".'weekabbrs : [ "'.$days['SUNDAY'].'", "'.$days['MONDAY'].'", "'.$days['TUESDAY'].'", "'.$days['WEDNESDAY'].'", "'.$days['THURSDAY'].'", "'.$days['FRIDAY'].'", "'.$days['SATURDAY'].'" ],';
			foreach ( $days as $k=>$v ) {
				$day		=	str_replace( $v, '', JText::_( $k ) );
				$days[$k]	=	addslashes( $v.'<span class="hidden-phone">'.$day.'</span>' );	
			}
			$js		.=	"\n".'weeks : [ "'.$days['SUNDAY'].'", "'.$days['MONDAY'].'", "'.$days['TUESDAY'].'", "'.$days['WEDNESDAY'].'", "'.$days['THURSDAY'].'", "'.$days['FRIDAY'].'", "'.$days['SATURDAY'].'" ],';
		}elseif($format == 3){
			$js	.=	"\n".'weekabbrs : [ "'.substr( JText::_( 'SUND' ),0,1).'", "'.substr(JText::_( 'MOND' ),0,1).'", "'.substr(JText::_( 'TUES' ),0,1).'", "'.substr(JText::_( 'WEDN' ),0,1).'", "'.substr(JText::_( 'THUR' ),0,1).'", "'.substr(JText::_( 'FRID' ),0,1).'", "'.substr(JText::_( 'SATU' ),0,1).'" ],'
				.	"\n".'weeks : [ "'.substr(JText::_( 'SUNDAY' ),0,1).'", "'.substr(JText::_( 'MONDAY' ),0,1).'", "'.substr(JText::_( 'TUESDAY' ),0,1).'", "'.substr(JText::_( 'WEDNESDAY' ),0,1).'", "'.substr(JText::_( 'THURSDAY' ),0,1).'", "'.substr(JText::_( 'FRIDAY' ),0,1).'", "'.substr(JText::_( 'SATURDAY' ),0,1).'" ],';
		}else {
			if($format == 0){ // complet 
			/* gege modif */
			$js	.=	"\n".'weekabbrs : [ "'.JText::_( 'SUND' ).'", "'.JText::_( 'MOND' ).'", "'.JText::_( 'TUES' ).'", "'.JText::_( 'WEDN' ).'", "'.JText::_( 'THUR' ).'", "'.JText::_( 'FRID' ).'", "'.JText::_( 'SATU' ).'" ],'
				.	"\n".'weeks : [ "'.JText::_( 'SUNDAY' ).'", "'.JText::_( 'MONDAY' ).'", "'.JText::_( 'TUESDAY' ).'", "'.JText::_( 'WEDNESDAY' ).'", "'.JText::_( 'THURSDAY' ).'", "'.JText::_( 'FRIDAY' ).'", "'.JText::_( 'SATURDAY' ).'" ],';
			}else{
				$js	.=	"\n".'weekabbrs : [ "'.JText::_( 'SUN' ).'", "'.JText::_( 'MON' ).'", "'.JText::_( 'TUE' ).'", "'.JText::_( 'WED' ).'", "'.JText::_( 'THU' ).'", "'.JText::_( 'FRI' ).'", "'.JText::_( 'SAT' ).'" ],'
					.	"\n".'weeks : [ "'.JText::_( 'SUND' ).'", "'.JText::_( 'MOND' ).'", "'.JText::_( 'TUES' ).'", "'.JText::_( 'WEDN' ).'", "'.JText::_( 'THUR' ).'", "'.JText::_( 'FRID' ).'", "'.JText::_( 'SATU' ).'" ],';
			}
		}

		return $js;
	}
}
?>
