<?php
/**
* @version 			SEBLOD 3.x More
* @package			SEBLOD (App Builder & CCK) // SEBLOD nano (Form Builder)
* @url				http://www.seblod.com
* @editor			Octopoos - www.octopoos.com
* @copyright		Copyright (C) 2013 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
**/


defined( '_JEXEC' ) or die;

if ( JCck::on() ) {
	JHtml::_( 'bootstrap.framework' );
	JHtml::_( 'bootstrap.tooltip' );
}

// -- Initialize
require_once dirname(__FILE__).'/config.php';
$cck	=	CCK_Rendering::getInstance( $this->template );
if ( $cck->initialize() === false ) { return; }

CONST HIGHEST_PRIORITY_LEVEL = 0;
CONST LOWEST_PRIORITY_LEVEL = 2;
CONST DEFAULT_PRIORITY_LEVEL = 1;

$calendar_id	=	$cck->id; //todo
$display_mode	=	$cck->getStyleParam( 'calendar_display', '0' );
$events			=	'';
$labels			=	'';
$i				=	0;
$items			=	$cck->getItems();
$infowindow		= 	$cck->getStyleParam( 'calendar_infowindow', 0 );

$infowindow_body=	'';
$infowindow_type=	'';
$layout 		=	$cck->getStyleParam( 'calendar_layout', 'responsive' );
$layout			=	( $layout != '_' ) ? ' '.$layout : '';
$style			=	$cck->getStyleParam( 'calendar_style', 'style1' );
$title_typo		=	(boolean)$cck->getStyleParam( 'title_typo',false);

$f_start_date	=	$cck->getFields( 'startdate', '', false );
$f_end_date		=	$cck->getFields( 'enddate', '', false );
$f_priority		=	$cck->getFields( 'priority' , '' , false );
$f_frequency	=	$cck->getFields( 'frequency' , '' , false );
$f_notworkingdays	=	$cck->getFields( 'notworkingdays', '', false );

$f_title		=	$cck->getFields( 'title', '', false );
$f_title		=	$f_title[0];

$onclick_js		=	'';
$popover_js		=	'';
$selector		=	'';
$slideover_js	=	'';

$orderCck = array($cckException,'default',$cckRepeat);

if ( $infowindow ) {
	$infowindow_type		= 	$cck->getStyleParam( 'calendar_infowindow_type', 'popover' );

	if ( $infowindow == '2' ) {
		$infowindow_body	=	$cck->getFields( 'infowindow_body', '', false );
		$f_title2			=	$cck->getFields( 'infowindow_heading', '', false );
		$f_title2			=	( isset( $f_title2[0] ) ) ? $f_title2[0] : '';
	} else {
		$infowindow_body	=	$cck->getFields( 'infowindow', '', false );
		$f_title2			=	$f_title;			
	}

	if ( $infowindow_type == 'popover' ) {
		
		$selector			=	'hasPopover_'.$calendar_id;
		
		$params				=	array(
									'animation'=>( $cck->getStyleParam( 'calendar_infowindow_animation', 1 ) ? 'true' : 'false' ),
									'placement'=>$cck->getStyleParam( 'calendar_infowindow_placement', 'top' ),
									'trigger'=>$cck->getStyleParam( 'calendar_infowindow_trigger', 'hover' )
							);
		
		switch($params['placement']){
			case 'right':
				$position = '{my: "left center", at: "right+20 top+5%"}';
				$tooltip_classes = 'rightTooltip';
				break;
			case 'left':
				$position = '{my: "right center", at: "left-12 top+5%"}';
				$tooltip_classes = 'leftTooltip';
				break;
			case 'bottom':
				$position = '{my: "center center", at: "center+50% center"}';
				$tooltip_classes = 'bottomTooltip';
				break;
			default:
				$position = '{my: "center bottom", at: "center+50% top-8%"}';
				$tooltip_classes = 'topTooltip';
				break;
		}
		
		$popover_js				=	'
				$(\'.ui-tooltip\').addClass("'. $tooltip_classes.'");				
 				$( ".'.$selector.'" ).parent().mouseOverTooltip({
						items: ".fc-day",
 						position: '.$position.',
						opacity: 0.9,
						// show: { effect: "blind", duration: 500 },
						// onShow: function() {
  // this.getTrigger().fadeTo("slow", 0.8);
  // },
						closeTimeout: 500, 
						content: 
						function(){
						$( ".'.$selector.'" ).parent().mouseenter(function(){
							$(\'.ui-tooltip\').css(\'z-index\', 11000);
							$(\'.ui-tooltip\').addClass("'. $tooltip_classes.'");
						});		
						$( ".'.$selector.'" ).parent().mouseleave(function(){
							$(\'.ui-tooltip\').css(\'z-index\', 5000);
								
						});	
	
							dateProperties={day:		$(\'.fc-date\',$(this)).text(),
								monthname:	$(\'#fh-month\').text(),
								year:		$(\'#fh-year\').text()
							};	
					
							var content = $(this).find(\'.fc-popover\').attr("data-content");
							return content;
						} 
		});


						';
						
						
		$slideover_js		=	'';
		$onclick_js		=	'onDayClick : function($el, $contentEl, dateProperties) {},';
		
	} elseif ( $infowindow_type == 'slideover' ) {
		$popover_js			=	'';
		$selector			=	'';
		$slideover_js		=	'
								function showInfo($contentEl, dateProperties) {
									hideInfo();
									var $iw = $( \'<div id="custom-content-reveal" class="custom-content-reveal"><h4>\' + dateProperties.monthname + \' \' + dateProperties.day + \', \' + dateProperties.year + \'</h4></div>\' );
									var $close = $( \'<span class="custom-content-close"></span>\' ).on( \'click\', hideInfo );

									$iw.append( $contentEl.attr("data-content") , $close ).insertAfter( $wrapper );
				
									setTimeout( function() { $iw.css( "top", "0%" ); }, 25 );
								}
								function hideInfo() {
									var $iw = $("#custom-content-reveal");
									if ($iw.length > 0) { $iw.css("top", "100%").remove(); }
								}
								';
		$onclick_js			=	'onDayClick : function($el, $contentEl, dateProperties) { if( $contentEl.length > 0 ) { showInfo( $contentEl, dateProperties ); } },';
	}
}else{
	$f_title2			=	$f_title;
}
$multiple   	= ( count( $infowindow_body ) > 1 ) ? true : false;

// gege modification add repetitions

$notworkingdays 	=	$cck->getStyleParam('not_workingdays','ev_event_notworkingdays');

$separatorHtml	=	' </br> ';
$separatorTitle	=	'   ';
$separatorText	=	'   ';
$separatorClasses	=	' ';

$array_events = array();


if (!function_exists('addEvent')) {
	/**
	 * addEvent to the array $array_events given in parameters
	 *
	 * @param CCK_Item $item
	 * @param array $array_events
	 * @param string $date1
	 * @param array $params
	 * @param string $date2
	 * @param string $freq
	 */
	function addEvent($item,&$array_events,$date1,$params,$date2=null,$freq='day'){
		
		extract($params);
				
		$notWorkingdaysArray = array('samedi','saturday','dimanche','sunday');
		
		$separatorHtml	=	' </br> ';
		$separatorTitle	=	'   ';
		$separatorText	=	'   ';

		
		if ( $infowindow ) {
			if ( $infowindow == '2' ) {
				
				$title	=	htmlspecialchars( $item->renderField( $f_title2 ) );
			} else {
				if($title_typo){
					$title	=	$item->renderField($f_title2);
				}else{
					$target	=	$item->getTypo_target( $f_title2 );
					$title	=	$item->{'get'.$target}( $f_title2 );
				}
				$title	=	addslashes( $title );
				//TODO modif here, but not enough
			}
			$text	=	'';

			foreach ( $infowindow_body as $iw ) {	
						
				$content = $item->renderField( $iw );
				
				// just for deleting links
				/*
				if($item->cck == $cckRepeat){ // TODO depending configuration
					$content = preg_replace("#<a.*?>#", "", $content);					
					$content = preg_replace("#</a>#", "", $content);
				}*/
				
				if ( $content != '' && ( $multiple || $item->getMarkup_Class( $iw ) ) ) {
					$text .= '<div class="cck-clrfix'.$item->getMarkup_Class( $iw ).' '.$item->cck.'">'.$content.'</div>';
				} else {
					
					$text .= $content;
				}
			}
			$text	=	htmlspecialchars( $text );

			if($infowindow == '2' && !empty($title) ){
				$text = "<div class='head_infowindow'>".$title."</div><div class='content_infowindow'>".$text."</div>";
			}
		}else{
		// gege test
			if($title_typo){
					$text	=	$item->renderField($f_title2);
			}else{
				$target	=	$item->getTypo_target( $f_title2 );
				$title	=	$item->{'get'.$target}( $f_title2 );
				$text = $title;
			}
		}
		
		// add event to $date1
		$date	=	JFactory::getDate( $date1 );
		$date1	=	$date->format( 'Y-m-d' );

		$dayName = strtolower(JFactory::getDate( $date )->format('l'));
		
// 		if(!($item->getValue($notworkingdays) && in_array($dayName, $notWorkingdaysArray) )){
		if(($item->notworkingdays  && in_array($dayName, $notWorkingdaysArray)) || !in_array($dayName, $notWorkingdaysArray)){
			
			// add only if $item->priority not
			for($i = 0;$i<$item->priority;$i++){
				// if already existing previous event with better priority, don't bother add this one
				if(count($array_events[$datet1][$i]))
					return;
			}
		
			$rank = count($array_events[$date1][$item->priority]);
			$rank = $rank > 0 ? $rank -1 : 0;		
					
			// SEE HERE GEGE
			$html = '';
//			$array_events[$date1][$item->priority][$rank]['html']	.=	( $first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\' title=\''.$title.'\'> '.$html.'</div>';
//			i$array_events[$date1][$item->priority][$rank]['html']	.=	( $first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\' title=\''.$title.'\'> '.$title.'</div>';
			$array_events[$date1][$item->priority][$rank]['html']	.=	( $first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\' title=\''.strip_tags($title).'\'> '.$title.'</div>';
			$array_events[$date1][$item->priority][$rank]['title']	.=	($first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\'> '.$title.'</div>';
			$array_events[$date1][$item->priority][$rank]['text']	.=	($first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\'> '.$text.'</div>';
			$array_events[$date1][$item->priority][$rank]['classes']	.=	strstr($array_events[$date1][$item->priority][$rank]['classes'] ,' agenda_'.$item->cck.' ')  === false ? ' agenda_'.$item->cck.' ' : '';
			for($i = $item->priority+1;$i<=LOWEST_PRIORITY_LEVEL && count($array_events[$date1][$i]);$i++){
				// if already existing previous event with lower priority, delete these ones
					$array_events[$date1][$i] = array();
			}
		}
		
		if(is_null($date2)) return;
			
		while ( $date1 < $date2 ) {
		
			$date	=	JFactory::getDate( $date1.' +1 '. $freq );

			$date1	=	$date->format( 'Y-m-d' );
			
			$dayName = strtolower(JFactory::getDate( $date )->format('l'));			
			
			for($i = 0;$i<$item->priority;$i++){
				// if already existing previous event with better priority, not even add this one
				if(count($array_events[$date1][$i]))
					return;
			}
			
			if(!$item->notworkingdays && in_array($dayName, $notWorkingdaysArray) )
				continue;
			
			$rank = count($array_events[$date1][$item->priority]);
			$rank = $rank > 0 ? $rank -1 : 0;
			
			// 		$array_events[JFactory::getDate( $date )->format( 'Y-m-d' )][$item->cck][$rank]['html']	.=	( $first ? $separatorHtml : '' ).'<div title=\'tru\' class='.$item->cck.'> '.$html.'</div>';
			$html = '';
			$array_events[$date1][$item->priority][$rank]['html']   .=      ( $first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\' title=\''.strip_tags($title).'\'> '.$title.'</div>';
//			$array_events[$date1][$item->priority][$rank]['html']	.=	( $first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\' title=\''.$title.'\'> '.$html.'</div>';
			$array_events[$date1][$item->priority][$rank]['title']	.=	($first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\'> '.$title.'</div>';
			$array_events[$date1][$item->priority][$rank]['text']	.=	($first ? $separatorHtml : '' ).'<div class=\'agenda_'.$item->cck.' priority_'. $item->priority.'\'> '.$text.'</div>';
			$array_events[$date1][$item->priority][$rank]['classes']	.=	strstr($array_events[$date1][$item->priority][$rank]['classes'] ,' agenda_'.$item->cck.' ')  === false ? ' agenda_'.$item->cck.' ' : '';
			
			for($i = $item->priority+1;$i<LOWEST_PRIORITY_LEVEL;$i++){
				// if already existing previous event with better priority, don't bother add this one
				if(count($array_events[$date1][$item->priority]))
					$array_events[$date1][$item->priority] = array();
			}
		}
	}
}

if (!function_exists('addRegularEvent')) {
	function addRegularEvent($item,&$array_events,$date1,$params,$freq){
		
		extract($params);
		
		switch ($freq){
			case 'w':$maxDelay = ' +1 year';
				$freq	=	'week';
				break;
			case 'm':$maxDelay = ' +1 year';
				$freq	=	'month';
				break;
			case 'y':$maxDelay = ' +10 year';
				$freq	=	'year';
				break;
			default : $maxDelay = ' +1 year';
				$freq	=	'day';
				break;
		}
	
		$maxDelayDate = JFactory::getDate('now'.$maxDelay)->format('Y-m-d');			
			
		if ( isset( $f_end_date[0] ) ) {
		
			$date2	=	$item->getValue( $f_end_date[0] );
		
			$date2	=	(isset($date2) && !empty($date2)) ? JFactory::getDate( $date2 )->format( 'Y-m-d' ) : $maxDelayDate;
			
		}else{
			$date2	=	$maxDelayDate;
		}
		
		addEvent($item, $array_events, $date1,$params,$date2,$freq);
		
	}
}

if ( count( $items ) ) {
	/* @var $item CCK_Item */
	foreach( $items as $item ) {
		$date1 = null;
		foreach($f_start_date as $startDate_field){
			try{
				$t = $item->getField($startDate_field);
				if(isset($t) && $t !== ''){
					$date1 = $item->getValue($startDate_field);
					$dateTime = new DateTime($date1);
					$date1	=	$dateTime->format('Y-m-d');
					break;
				}
			}catch(Exception $ex){
				continue;
			}
		}
		if ( !$date1 ) {
			continue;
		}
		
		$date2 = null;
		foreach($f_end_date as $endDate_field){
			$t = $item->getField($endDate_field);
			if(isset($t) && $t !== ''){
				$date2 = $item->getValue($endDate_field);
				$dateTime = new DateTime($date2);
				$date2	=	$dateTime->format('Y-m-d');
				break;
			}
		}
		
		$date2 = $date2 == $date1 ? null : $date2;
		
		$notworkingdays = 0;
		foreach($f_notworkingdays as $notworkingdays_field){
			$t = $item->getField($notworkingdays_field);
			if(isset($t) && $t !== ''){
				$notworkingdays = $item->getValue($notworkingdays_field);
				break;
			}
		}
		$item->notworkingdays = $notworkingdays;
		
		$html		=	addslashes( $item->renderField( $f_title ) );
		
		if ( !$html ) {
			continue;
		}

		//$infowindow,$f_title2,$f_end_date
		$params = array('infowindow'=>$infowindow,'f_title2'=>$f_title2,'f_end_date'=>$f_end_date,'infowindow_body'=>$infowindow_body,'html'=>$html,'title_typo'=>$title_typo);		
		$params['notworkingdays'] = $notworkingdays;
		
		$bool = false;
		$item->priority = DEFAULT_PRIORITY_LEVEL;
		
		$id = $item->getField('art_id');
		
		foreach($f_priority as $priority_field){
			
			$t = $item->getField($priority_field);
			
			if(isset($t) && !is_null($t) && $t !== ""){
				$item->priority = intval( $item->getValue($priority_field) );
				$item->priority = $item->priority > LOWEST_PRIORITY_LEVEL ? LOWEST_PRIORITY_LEVEL : $item->priority;
				$item->priority = $item->priority < HIGHEST_PRIORITY_LEVEL ? HIGHEST_PRIORITY_LEVEL : $item->priority;
				break;
			}
		}
		
		$bool = false;
		foreach($f_frequency as $frequency_field){
			$t = $item->getField($frequency_field);
			
			if(isset($t) && $t !== ''){
				addRegularEvent($item, $array_events, $date1, $params, $item->getValue($frequency_field));
				$bool=true;
				break;
			}
		}
		if(!$bool){
			addEvent($item, $array_events, $date1,$params,$date2);
		}
	}
}

//var_dump($array_events["2015-09-30"][1][0]["html"]);die();
foreach($array_events as $date => $day_event){
	$dateTime = new DateTime($date);
	$date	=	$dateTime->format('m-d-Y');
	
	$html = $title = $text = $classes = "";
	
	foreach($day_event as $cck_event => $eventsCck)
		foreach ($eventsCck as $event){
		
			$html		.=	(!empty($html) ? $separatorHtml : '')	.	$event['html'];	
//			$title	.=	(!empty($title) ? $separatorHtml : '')	.	$event['title'];
			$text		.=	(!empty($text) ? $separatorHtml : '')	.	$event['text'];
			$classes	.=	(!empty($classes) ? $separatorClasses : '')	.	$cck_event;
		}

	$html = str_replace('"',"'",$html);
	$title = str_replace('"',"'",$title);
	$text = str_replace('"',"'",$text);
	$events .= '"'.$date.'":{html:"'.$html.'",title:"'.$title.'",text:"'.$text.'",classes:"'.$classes.'"';
	$events .=	'},';
}

if ( $events != '' ) {
	$events	=	substr( $events, 0, -1 );
}

$weeks	=	$cck->getStyleParam( 'calendar_weeks', 0 );
if ( JFactory::getLanguage()->getTag() != 'en-GB' || $weeks == 2 ) {
	$labels	=	pulsar_calendar_getLabels( $weeks );
	$weeks	=	'';
} elseif ( $weeks ) {
	$weeks	=	',displayWeekAbbr : true';
} else {
	$weeks	=	'';
}

//echo $events;die();

// $events = '"05-25-2015":{title:"event1",text:"detail1"},"05-26-2015":{title:"event1",text:"detail1"},"05-27-2015":{title:"event2",text:"detail2"}';

$js	=	'
		jQuery(document).ready(function($) {
			var myEvents = {'.$events.'};
			$wrapper = $( "#custom-inner" );
			$("#'.$calendar_id.'_calendar").calendario({caldata : myEvents});
			var cal = $("#'.$calendar_id.'_calendar").calendario( {'.$labels.$onclick_js.'
					caldata : myEvents,
					//ligne qui fait une diff
					popover : '.( $infowindow_type ? '"'.$infowindow_type.'"' : '""' ).',
					popoverSelector : "'.$selector.'"'.$weeks.'
				} ),
				$month = $("#fh-month").html(cal.getMonthName()),
				$year = $("#fh-year").html(cal.getYear());
			$("#fh-next").on("click", function() { cal.gotoNextMonth( updateMonthYear );'.$popover_js.' });
			$("#fh-prev").on("click", function() { cal.gotoPreviousMonth( updateMonthYear );'.$popover_js.' });
			$("#fh-current").on("click", function() { cal.gotoNow( updateMonthYear );'.$popover_js.' });
			function updateMonthYear() {
				$month.html(cal.getMonthName());
				$year.html(cal.getYear());
			}'.$slideover_js.$popover_js.'
		});
		'
		;

$cck->addStyleSheet( $cck->base.'/templates/'.$cck->template. '/css/'.$style.'.css' );
$cck->addStyleSheet( $cck->base.'/templates/'.$cck->template. '/css/jquery.ui.tooltip.css' );

$cck->addScript( $cck->base.'/templates/'.$cck->template. '/js/jquery.calendario.js' );
$cck->addScript( $cck->base.'/templates/'.$cck->template. '/js/jquery-ui.min.js' );
$cck->addScript( $cck->base.'/templates/'.$cck->template. '/js/mouseOverTooltip.js' );

$cck->addScriptDeclaration( $js );
?>

<div id="<?php echo $calendar_id; ?>" class="<?php echo $style.$layout.' '.$cck->id_class; ?>">
	<div id="custom-inner" class="fh-header clearfix">
		<div class="fh-month-year">
		<!--<h3 class="fh-month-year ">   modif agathe w3c -->
			<nav>
	            <span id="fh-current" class="icon-calendar hasTooltip" title="<?php echo JText::_( 'COM_CCK_TODAY' ); ?>"></span>
				<span id="fh-prev" class="icon-arrow-left hasTooltip" title="<?php echo JText::_( 'COM_CCK_PREVIOUS_MONTH' ); ?>"></span>
				<span id="fh-next" class="icon-arrow-right hasTooltip" title="<?php echo JText::_( 'COM_CCK_NEXT_MONTH' ); ?>"></span>	
			</nav>
			<div class="currentDateString">
	            <span id="fh-month" class="fh-month"></span>
				<span id="fh-year" class="fh-year"></span>
			</div>
		<!--</h3>      modif agathe w3c   -->
		</div>
	</div>
	<div id="<?php echo $calendar_id; ?>_calendar" class="fc-calendar-container"></div>
</div>
